org.apache.sysds.parser.dml

## Interface DmlListener

- All Superinterfaces:
    org.antlr.v4.runtime.tree.ParseTreeListener
  All Known Implementing Classes:
    DmlBaseListener, DmlPreprocessor, DmlSyntacticValidator

      public interface DmlListener
      extends org.antlr.v4.runtime.tree.ParseTreeListener

  This interface defines a complete listener for a parse tree produced by `DmlParser`.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `enterAccumulatorAssignmentStatement(DmlParser.AccumulatorAssignmentStatementContext ctx)` Enter a parse tree produced by the `AccumulatorAssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterAddSubExpression(DmlParser.AddSubExpressionContext ctx)` Enter a parse tree produced by the `AddSubExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterAssignmentStatement(DmlParser.AssignmentStatementContext ctx)` Enter a parse tree produced by the `AssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterAtomicExpression(DmlParser.AtomicExpressionContext ctx)` Enter a parse tree produced by the `AtomicExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterBooleanAndExpression(DmlParser.BooleanAndExpressionContext ctx)` Enter a parse tree produced by the `BooleanAndExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterBooleanNotExpression(DmlParser.BooleanNotExpressionContext ctx)` Enter a parse tree produced by the `BooleanNotExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterBooleanOrExpression(DmlParser.BooleanOrExpressionContext ctx)` Enter a parse tree produced by the `BooleanOrExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterBuiltinFunctionExpression(DmlParser.BuiltinFunctionExpressionContext ctx)` Enter a parse tree produced by the `BuiltinFunctionExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterCommandlineParamExpression(DmlParser.CommandlineParamExpressionContext ctx)` Enter a parse tree produced by the `CommandlineParamExpression` labeled alternative in `DmlParser.dataIdentifier()`.
    `void` | `enterCommandlinePositionExpression(DmlParser.CommandlinePositionExpressionContext ctx)` Enter a parse tree produced by the `CommandlinePositionExpression` labeled alternative in `DmlParser.dataIdentifier()`.
    `void` | `enterConstDoubleIdExpression(DmlParser.ConstDoubleIdExpressionContext ctx)` Enter a parse tree produced by the `ConstDoubleIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterConstFalseExpression(DmlParser.ConstFalseExpressionContext ctx)` Enter a parse tree produced by the `ConstFalseExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterConstIntIdExpression(DmlParser.ConstIntIdExpressionContext ctx)` Enter a parse tree produced by the `ConstIntIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterConstStringIdExpression(DmlParser.ConstStringIdExpressionContext ctx)` Enter a parse tree produced by the `ConstStringIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterConstTrueExpression(DmlParser.ConstTrueExpressionContext ctx)` Enter a parse tree produced by the `ConstTrueExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterDataIdExpression(DmlParser.DataIdExpressionContext ctx)` Enter a parse tree produced by the `DataIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterExternalFunctionDefExpression(DmlParser.ExternalFunctionDefExpressionContext ctx)` Enter a parse tree produced by the `ExternalFunctionDefExpression` labeled alternative in `DmlParser.functionStatement()`.
    `void` | `enterForStatement(DmlParser.ForStatementContext ctx)` Enter a parse tree produced by the `ForStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterFunctionCallAssignmentStatement(DmlParser.FunctionCallAssignmentStatementContext ctx)` Enter a parse tree produced by the `FunctionCallAssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterFunctionCallMultiAssignmentStatement(DmlParser.FunctionCallMultiAssignmentStatementContext ctx)` Enter a parse tree produced by the `FunctionCallMultiAssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterIfdefAssignmentStatement(DmlParser.IfdefAssignmentStatementContext ctx)` Enter a parse tree produced by the `IfdefAssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterIfStatement(DmlParser.IfStatementContext ctx)` Enter a parse tree produced by the `IfStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterImportStatement(DmlParser.ImportStatementContext ctx)` Enter a parse tree produced by the `ImportStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterIndexedExpression(DmlParser.IndexedExpressionContext ctx)` Enter a parse tree produced by the `IndexedExpression` labeled alternative in `DmlParser.dataIdentifier()`.
    `void` | `enterInternalFunctionDefExpression(DmlParser.InternalFunctionDefExpressionContext ctx)` Enter a parse tree produced by the `InternalFunctionDefExpression` labeled alternative in `DmlParser.functionStatement()`.
    `void` | `enterIterablePredicateColonExpression(DmlParser.IterablePredicateColonExpressionContext ctx)` Enter a parse tree produced by the `IterablePredicateColonExpression` labeled alternative in `DmlParser.iterablePredicate()`.
    `void` | `enterIterablePredicateSeqExpression(DmlParser.IterablePredicateSeqExpressionContext ctx)` Enter a parse tree produced by the `IterablePredicateSeqExpression` labeled alternative in `DmlParser.iterablePredicate()`.
    `void` | `enterMatrixDataTypeCheck(DmlParser.MatrixDataTypeCheckContext ctx)` Enter a parse tree produced by the `MatrixDataTypeCheck` labeled alternative in `DmlParser.dataType()`.
    `void` | `enterMatrixMulExpression(DmlParser.MatrixMulExpressionContext ctx)` Enter a parse tree produced by the `MatrixMulExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterMl_type(DmlParser.Ml_typeContext ctx)` Enter a parse tree produced by `DmlParser.ml_type()`.
    `void` | `enterModIntDivExpression(DmlParser.ModIntDivExpressionContext ctx)` Enter a parse tree produced by the `ModIntDivExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterMultDivExpression(DmlParser.MultDivExpressionContext ctx)` Enter a parse tree produced by the `MultDivExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterMultiIdExpression(DmlParser.MultiIdExpressionContext ctx)` Enter a parse tree produced by the `MultiIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterParameterizedExpression(DmlParser.ParameterizedExpressionContext ctx)` Enter a parse tree produced by `DmlParser.parameterizedExpression()`.
    `void` | `enterParForStatement(DmlParser.ParForStatementContext ctx)` Enter a parse tree produced by the `ParForStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterPathStatement(DmlParser.PathStatementContext ctx)` Enter a parse tree produced by the `PathStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `enterPowerExpression(DmlParser.PowerExpressionContext ctx)` Enter a parse tree produced by the `PowerExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterProgramroot(DmlParser.ProgramrootContext ctx)` Enter a parse tree produced by `DmlParser.programroot()`.
    `void` | `enterRelationalExpression(DmlParser.RelationalExpressionContext ctx)` Enter a parse tree produced by the `RelationalExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterSimpleDataIdentifierExpression(DmlParser.SimpleDataIdentifierExpressionContext ctx)` Enter a parse tree produced by the `SimpleDataIdentifierExpression` labeled alternative in `DmlParser.dataIdentifier()`.
    `void` | `enterStrictParameterizedExpression(DmlParser.StrictParameterizedExpressionContext ctx)` Enter a parse tree produced by `DmlParser.strictParameterizedExpression()`.
    `void` | `enterStrictParameterizedKeyValueString(DmlParser.StrictParameterizedKeyValueStringContext ctx)` Enter a parse tree produced by `DmlParser.strictParameterizedKeyValueString()`.
    `void` | `enterTypedArgAssign(DmlParser.TypedArgAssignContext ctx)` Enter a parse tree produced by `DmlParser.typedArgAssign()`.
    `void` | `enterTypedArgNoAssign(DmlParser.TypedArgNoAssignContext ctx)` Enter a parse tree produced by `DmlParser.typedArgNoAssign()`.
    `void` | `enterUnaryExpression(DmlParser.UnaryExpressionContext ctx)` Enter a parse tree produced by the `UnaryExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `enterValueType(DmlParser.ValueTypeContext ctx)` Enter a parse tree produced by `DmlParser.valueType()`.
    `void` | `enterWhileStatement(DmlParser.WhileStatementContext ctx)` Enter a parse tree produced by the `WhileStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitAccumulatorAssignmentStatement(DmlParser.AccumulatorAssignmentStatementContext ctx)` Exit a parse tree produced by the `AccumulatorAssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitAddSubExpression(DmlParser.AddSubExpressionContext ctx)` Exit a parse tree produced by the `AddSubExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitAssignmentStatement(DmlParser.AssignmentStatementContext ctx)` Exit a parse tree produced by the `AssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitAtomicExpression(DmlParser.AtomicExpressionContext ctx)` Exit a parse tree produced by the `AtomicExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitBooleanAndExpression(DmlParser.BooleanAndExpressionContext ctx)` Exit a parse tree produced by the `BooleanAndExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitBooleanNotExpression(DmlParser.BooleanNotExpressionContext ctx)` Exit a parse tree produced by the `BooleanNotExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitBooleanOrExpression(DmlParser.BooleanOrExpressionContext ctx)` Exit a parse tree produced by the `BooleanOrExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitBuiltinFunctionExpression(DmlParser.BuiltinFunctionExpressionContext ctx)` Exit a parse tree produced by the `BuiltinFunctionExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitCommandlineParamExpression(DmlParser.CommandlineParamExpressionContext ctx)` Exit a parse tree produced by the `CommandlineParamExpression` labeled alternative in `DmlParser.dataIdentifier()`.
    `void` | `exitCommandlinePositionExpression(DmlParser.CommandlinePositionExpressionContext ctx)` Exit a parse tree produced by the `CommandlinePositionExpression` labeled alternative in `DmlParser.dataIdentifier()`.
    `void` | `exitConstDoubleIdExpression(DmlParser.ConstDoubleIdExpressionContext ctx)` Exit a parse tree produced by the `ConstDoubleIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitConstFalseExpression(DmlParser.ConstFalseExpressionContext ctx)` Exit a parse tree produced by the `ConstFalseExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitConstIntIdExpression(DmlParser.ConstIntIdExpressionContext ctx)` Exit a parse tree produced by the `ConstIntIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitConstStringIdExpression(DmlParser.ConstStringIdExpressionContext ctx)` Exit a parse tree produced by the `ConstStringIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitConstTrueExpression(DmlParser.ConstTrueExpressionContext ctx)` Exit a parse tree produced by the `ConstTrueExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitDataIdExpression(DmlParser.DataIdExpressionContext ctx)` Exit a parse tree produced by the `DataIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitExternalFunctionDefExpression(DmlParser.ExternalFunctionDefExpressionContext ctx)` Exit a parse tree produced by the `ExternalFunctionDefExpression` labeled alternative in `DmlParser.functionStatement()`.
    `void` | `exitForStatement(DmlParser.ForStatementContext ctx)` Exit a parse tree produced by the `ForStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitFunctionCallAssignmentStatement(DmlParser.FunctionCallAssignmentStatementContext ctx)` Exit a parse tree produced by the `FunctionCallAssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitFunctionCallMultiAssignmentStatement(DmlParser.FunctionCallMultiAssignmentStatementContext ctx)` Exit a parse tree produced by the `FunctionCallMultiAssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitIfdefAssignmentStatement(DmlParser.IfdefAssignmentStatementContext ctx)` Exit a parse tree produced by the `IfdefAssignmentStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitIfStatement(DmlParser.IfStatementContext ctx)` Exit a parse tree produced by the `IfStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitImportStatement(DmlParser.ImportStatementContext ctx)` Exit a parse tree produced by the `ImportStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitIndexedExpression(DmlParser.IndexedExpressionContext ctx)` Exit a parse tree produced by the `IndexedExpression` labeled alternative in `DmlParser.dataIdentifier()`.
    `void` | `exitInternalFunctionDefExpression(DmlParser.InternalFunctionDefExpressionContext ctx)` Exit a parse tree produced by the `InternalFunctionDefExpression` labeled alternative in `DmlParser.functionStatement()`.
    `void` | `exitIterablePredicateColonExpression(DmlParser.IterablePredicateColonExpressionContext ctx)` Exit a parse tree produced by the `IterablePredicateColonExpression` labeled alternative in `DmlParser.iterablePredicate()`.
    `void` | `exitIterablePredicateSeqExpression(DmlParser.IterablePredicateSeqExpressionContext ctx)` Exit a parse tree produced by the `IterablePredicateSeqExpression` labeled alternative in `DmlParser.iterablePredicate()`.
    `void` | `exitMatrixDataTypeCheck(DmlParser.MatrixDataTypeCheckContext ctx)` Exit a parse tree produced by the `MatrixDataTypeCheck` labeled alternative in `DmlParser.dataType()`.
    `void` | `exitMatrixMulExpression(DmlParser.MatrixMulExpressionContext ctx)` Exit a parse tree produced by the `MatrixMulExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitMl_type(DmlParser.Ml_typeContext ctx)` Exit a parse tree produced by `DmlParser.ml_type()`.
    `void` | `exitModIntDivExpression(DmlParser.ModIntDivExpressionContext ctx)` Exit a parse tree produced by the `ModIntDivExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitMultDivExpression(DmlParser.MultDivExpressionContext ctx)` Exit a parse tree produced by the `MultDivExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitMultiIdExpression(DmlParser.MultiIdExpressionContext ctx)` Exit a parse tree produced by the `MultiIdExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitParameterizedExpression(DmlParser.ParameterizedExpressionContext ctx)` Exit a parse tree produced by `DmlParser.parameterizedExpression()`.
    `void` | `exitParForStatement(DmlParser.ParForStatementContext ctx)` Exit a parse tree produced by the `ParForStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitPathStatement(DmlParser.PathStatementContext ctx)` Exit a parse tree produced by the `PathStatement` labeled alternative in `DmlParser.statement()`.
    `void` | `exitPowerExpression(DmlParser.PowerExpressionContext ctx)` Exit a parse tree produced by the `PowerExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitProgramroot(DmlParser.ProgramrootContext ctx)` Exit a parse tree produced by `DmlParser.programroot()`.
    `void` | `exitRelationalExpression(DmlParser.RelationalExpressionContext ctx)` Exit a parse tree produced by the `RelationalExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitSimpleDataIdentifierExpression(DmlParser.SimpleDataIdentifierExpressionContext ctx)` Exit a parse tree produced by the `SimpleDataIdentifierExpression` labeled alternative in `DmlParser.dataIdentifier()`.
    `void` | `exitStrictParameterizedExpression(DmlParser.StrictParameterizedExpressionContext ctx)` Exit a parse tree produced by `DmlParser.strictParameterizedExpression()`.
    `void` | `exitStrictParameterizedKeyValueString(DmlParser.StrictParameterizedKeyValueStringContext ctx)` Exit a parse tree produced by `DmlParser.strictParameterizedKeyValueString()`.
    `void` | `exitTypedArgAssign(DmlParser.TypedArgAssignContext ctx)` Exit a parse tree produced by `DmlParser.typedArgAssign()`.
    `void` | `exitTypedArgNoAssign(DmlParser.TypedArgNoAssignContext ctx)` Exit a parse tree produced by `DmlParser.typedArgNoAssign()`.
    `void` | `exitUnaryExpression(DmlParser.UnaryExpressionContext ctx)` Exit a parse tree produced by the `UnaryExpression` labeled alternative in `DmlParser.expression()`.
    `void` | `exitValueType(DmlParser.ValueTypeContext ctx)` Exit a parse tree produced by `DmlParser.valueType()`.
    `void` | `exitWhileStatement(DmlParser.WhileStatementContext ctx)` Exit a parse tree produced by the `WhileStatement` labeled alternative in `DmlParser.statement()`.

    - ### Methods inherited from interface org.antlr.v4.runtime.tree.ParseTreeListener

      `enterEveryRule, exitEveryRule, visitErrorNode, visitTerminal`

- - ### Method Detail

    - #### enterProgramroot

          void enterProgramroot(DmlParser.ProgramrootContext ctx)

      Enter a parse tree produced by `DmlParser.programroot()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitProgramroot

          void exitProgramroot(DmlParser.ProgramrootContext ctx)

      Exit a parse tree produced by `DmlParser.programroot()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterImportStatement

          void enterImportStatement(DmlParser.ImportStatementContext ctx)

      Enter a parse tree produced by the `ImportStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitImportStatement

          void exitImportStatement(DmlParser.ImportStatementContext ctx)

      Exit a parse tree produced by the `ImportStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterPathStatement

          void enterPathStatement(DmlParser.PathStatementContext ctx)

      Enter a parse tree produced by the `PathStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitPathStatement

          void exitPathStatement(DmlParser.PathStatementContext ctx)

      Exit a parse tree produced by the `PathStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterFunctionCallAssignmentStatement

          void enterFunctionCallAssignmentStatement(DmlParser.FunctionCallAssignmentStatementContext ctx)

      Enter a parse tree produced by the `FunctionCallAssignmentStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitFunctionCallAssignmentStatement

          void exitFunctionCallAssignmentStatement(DmlParser.FunctionCallAssignmentStatementContext ctx)

      Exit a parse tree produced by the `FunctionCallAssignmentStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterFunctionCallMultiAssignmentStatement

          void enterFunctionCallMultiAssignmentStatement(DmlParser.FunctionCallMultiAssignmentStatementContext ctx)

      Enter a parse tree produced by the `FunctionCallMultiAssignmentStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitFunctionCallMultiAssignmentStatement

          void exitFunctionCallMultiAssignmentStatement(DmlParser.FunctionCallMultiAssignmentStatementContext ctx)

      Exit a parse tree produced by the `FunctionCallMultiAssignmentStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterIfdefAssignmentStatement

          void enterIfdefAssignmentStatement(DmlParser.IfdefAssignmentStatementContext ctx)

      Enter a parse tree produced by the `IfdefAssignmentStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitIfdefAssignmentStatement

          void exitIfdefAssignmentStatement(DmlParser.IfdefAssignmentStatementContext ctx)

      Exit a parse tree produced by the `IfdefAssignmentStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterAssignmentStatement

          void enterAssignmentStatement(DmlParser.AssignmentStatementContext ctx)

      Enter a parse tree produced by the `AssignmentStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitAssignmentStatement

          void exitAssignmentStatement(DmlParser.AssignmentStatementContext ctx)

      Exit a parse tree produced by the `AssignmentStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterAccumulatorAssignmentStatement

          void enterAccumulatorAssignmentStatement(DmlParser.AccumulatorAssignmentStatementContext ctx)

      Enter a parse tree produced by the `AccumulatorAssignmentStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitAccumulatorAssignmentStatement

          void exitAccumulatorAssignmentStatement(DmlParser.AccumulatorAssignmentStatementContext ctx)

      Exit a parse tree produced by the `AccumulatorAssignmentStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterIfStatement

          void enterIfStatement(DmlParser.IfStatementContext ctx)

      Enter a parse tree produced by the `IfStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitIfStatement

          void exitIfStatement(DmlParser.IfStatementContext ctx)

      Exit a parse tree produced by the `IfStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterForStatement

          void enterForStatement(DmlParser.ForStatementContext ctx)

      Enter a parse tree produced by the `ForStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitForStatement

          void exitForStatement(DmlParser.ForStatementContext ctx)

      Exit a parse tree produced by the `ForStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterParForStatement

          void enterParForStatement(DmlParser.ParForStatementContext ctx)

      Enter a parse tree produced by the `ParForStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitParForStatement

          void exitParForStatement(DmlParser.ParForStatementContext ctx)

      Exit a parse tree produced by the `ParForStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterWhileStatement

          void enterWhileStatement(DmlParser.WhileStatementContext ctx)

      Enter a parse tree produced by the `WhileStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitWhileStatement

          void exitWhileStatement(DmlParser.WhileStatementContext ctx)

      Exit a parse tree produced by the `WhileStatement` labeled alternative in `DmlParser.statement()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterIterablePredicateColonExpression

          void enterIterablePredicateColonExpression(DmlParser.IterablePredicateColonExpressionContext ctx)

      Enter a parse tree produced by the `IterablePredicateColonExpression` labeled alternative in `DmlParser.iterablePredicate()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitIterablePredicateColonExpression

          void exitIterablePredicateColonExpression(DmlParser.IterablePredicateColonExpressionContext ctx)

      Exit a parse tree produced by the `IterablePredicateColonExpression` labeled alternative in `DmlParser.iterablePredicate()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterIterablePredicateSeqExpression

          void enterIterablePredicateSeqExpression(DmlParser.IterablePredicateSeqExpressionContext ctx)

      Enter a parse tree produced by the `IterablePredicateSeqExpression` labeled alternative in `DmlParser.iterablePredicate()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitIterablePredicateSeqExpression

          void exitIterablePredicateSeqExpression(DmlParser.IterablePredicateSeqExpressionContext ctx)

      Exit a parse tree produced by the `IterablePredicateSeqExpression` labeled alternative in `DmlParser.iterablePredicate()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterInternalFunctionDefExpression

          void enterInternalFunctionDefExpression(DmlParser.InternalFunctionDefExpressionContext ctx)

      Enter a parse tree produced by the `InternalFunctionDefExpression` labeled alternative in `DmlParser.functionStatement()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitInternalFunctionDefExpression

          void exitInternalFunctionDefExpression(DmlParser.InternalFunctionDefExpressionContext ctx)

      Exit a parse tree produced by the `InternalFunctionDefExpression` labeled alternative in `DmlParser.functionStatement()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterExternalFunctionDefExpression

          void enterExternalFunctionDefExpression(DmlParser.ExternalFunctionDefExpressionContext ctx)

      Enter a parse tree produced by the `ExternalFunctionDefExpression` labeled alternative in `DmlParser.functionStatement()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitExternalFunctionDefExpression

          void exitExternalFunctionDefExpression(DmlParser.ExternalFunctionDefExpressionContext ctx)

      Exit a parse tree produced by the `ExternalFunctionDefExpression` labeled alternative in `DmlParser.functionStatement()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterIndexedExpression

          void enterIndexedExpression(DmlParser.IndexedExpressionContext ctx)

      Enter a parse tree produced by the `IndexedExpression` labeled alternative in `DmlParser.dataIdentifier()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitIndexedExpression

          void exitIndexedExpression(DmlParser.IndexedExpressionContext ctx)

      Exit a parse tree produced by the `IndexedExpression` labeled alternative in `DmlParser.dataIdentifier()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterSimpleDataIdentifierExpression

          void enterSimpleDataIdentifierExpression(DmlParser.SimpleDataIdentifierExpressionContext ctx)

      Enter a parse tree produced by the `SimpleDataIdentifierExpression` labeled alternative in `DmlParser.dataIdentifier()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitSimpleDataIdentifierExpression

          void exitSimpleDataIdentifierExpression(DmlParser.SimpleDataIdentifierExpressionContext ctx)

      Exit a parse tree produced by the `SimpleDataIdentifierExpression` labeled alternative in `DmlParser.dataIdentifier()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterCommandlineParamExpression

          void enterCommandlineParamExpression(DmlParser.CommandlineParamExpressionContext ctx)

      Enter a parse tree produced by the `CommandlineParamExpression` labeled alternative in `DmlParser.dataIdentifier()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitCommandlineParamExpression

          void exitCommandlineParamExpression(DmlParser.CommandlineParamExpressionContext ctx)

      Exit a parse tree produced by the `CommandlineParamExpression` labeled alternative in `DmlParser.dataIdentifier()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterCommandlinePositionExpression

          void enterCommandlinePositionExpression(DmlParser.CommandlinePositionExpressionContext ctx)

      Enter a parse tree produced by the `CommandlinePositionExpression` labeled alternative in `DmlParser.dataIdentifier()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitCommandlinePositionExpression

          void exitCommandlinePositionExpression(DmlParser.CommandlinePositionExpressionContext ctx)

      Exit a parse tree produced by the `CommandlinePositionExpression` labeled alternative in `DmlParser.dataIdentifier()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterModIntDivExpression

          void enterModIntDivExpression(DmlParser.ModIntDivExpressionContext ctx)

      Enter a parse tree produced by the `ModIntDivExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitModIntDivExpression

          void exitModIntDivExpression(DmlParser.ModIntDivExpressionContext ctx)

      Exit a parse tree produced by the `ModIntDivExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterRelationalExpression

          void enterRelationalExpression(DmlParser.RelationalExpressionContext ctx)

      Enter a parse tree produced by the `RelationalExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitRelationalExpression

          void exitRelationalExpression(DmlParser.RelationalExpressionContext ctx)

      Exit a parse tree produced by the `RelationalExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterBooleanNotExpression

          void enterBooleanNotExpression(DmlParser.BooleanNotExpressionContext ctx)

      Enter a parse tree produced by the `BooleanNotExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitBooleanNotExpression

          void exitBooleanNotExpression(DmlParser.BooleanNotExpressionContext ctx)

      Exit a parse tree produced by the `BooleanNotExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterPowerExpression

          void enterPowerExpression(DmlParser.PowerExpressionContext ctx)

      Enter a parse tree produced by the `PowerExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitPowerExpression

          void exitPowerExpression(DmlParser.PowerExpressionContext ctx)

      Exit a parse tree produced by the `PowerExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterBuiltinFunctionExpression

          void enterBuiltinFunctionExpression(DmlParser.BuiltinFunctionExpressionContext ctx)

      Enter a parse tree produced by the `BuiltinFunctionExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitBuiltinFunctionExpression

          void exitBuiltinFunctionExpression(DmlParser.BuiltinFunctionExpressionContext ctx)

      Exit a parse tree produced by the `BuiltinFunctionExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterConstIntIdExpression

          void enterConstIntIdExpression(DmlParser.ConstIntIdExpressionContext ctx)

      Enter a parse tree produced by the `ConstIntIdExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitConstIntIdExpression

          void exitConstIntIdExpression(DmlParser.ConstIntIdExpressionContext ctx)

      Exit a parse tree produced by the `ConstIntIdExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterAtomicExpression

          void enterAtomicExpression(DmlParser.AtomicExpressionContext ctx)

      Enter a parse tree produced by the `AtomicExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitAtomicExpression

          void exitAtomicExpression(DmlParser.AtomicExpressionContext ctx)

      Exit a parse tree produced by the `AtomicExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterConstStringIdExpression

          void enterConstStringIdExpression(DmlParser.ConstStringIdExpressionContext ctx)

      Enter a parse tree produced by the `ConstStringIdExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitConstStringIdExpression

          void exitConstStringIdExpression(DmlParser.ConstStringIdExpressionContext ctx)

      Exit a parse tree produced by the `ConstStringIdExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterConstTrueExpression

          void enterConstTrueExpression(DmlParser.ConstTrueExpressionContext ctx)

      Enter a parse tree produced by the `ConstTrueExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitConstTrueExpression

          void exitConstTrueExpression(DmlParser.ConstTrueExpressionContext ctx)

      Exit a parse tree produced by the `ConstTrueExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterUnaryExpression

          void enterUnaryExpression(DmlParser.UnaryExpressionContext ctx)

      Enter a parse tree produced by the `UnaryExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitUnaryExpression

          void exitUnaryExpression(DmlParser.UnaryExpressionContext ctx)

      Exit a parse tree produced by the `UnaryExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterMultDivExpression

          void enterMultDivExpression(DmlParser.MultDivExpressionContext ctx)

      Enter a parse tree produced by the `MultDivExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitMultDivExpression

          void exitMultDivExpression(DmlParser.MultDivExpressionContext ctx)

      Exit a parse tree produced by the `MultDivExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterConstFalseExpression

          void enterConstFalseExpression(DmlParser.ConstFalseExpressionContext ctx)

      Enter a parse tree produced by the `ConstFalseExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitConstFalseExpression

          void exitConstFalseExpression(DmlParser.ConstFalseExpressionContext ctx)

      Exit a parse tree produced by the `ConstFalseExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterDataIdExpression

          void enterDataIdExpression(DmlParser.DataIdExpressionContext ctx)

      Enter a parse tree produced by the `DataIdExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitDataIdExpression

          void exitDataIdExpression(DmlParser.DataIdExpressionContext ctx)

      Exit a parse tree produced by the `DataIdExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterAddSubExpression

          void enterAddSubExpression(DmlParser.AddSubExpressionContext ctx)

      Enter a parse tree produced by the `AddSubExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitAddSubExpression

          void exitAddSubExpression(DmlParser.AddSubExpressionContext ctx)

      Exit a parse tree produced by the `AddSubExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterConstDoubleIdExpression

          void enterConstDoubleIdExpression(DmlParser.ConstDoubleIdExpressionContext ctx)

      Enter a parse tree produced by the `ConstDoubleIdExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitConstDoubleIdExpression

          void exitConstDoubleIdExpression(DmlParser.ConstDoubleIdExpressionContext ctx)

      Exit a parse tree produced by the `ConstDoubleIdExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterMatrixMulExpression

          void enterMatrixMulExpression(DmlParser.MatrixMulExpressionContext ctx)

      Enter a parse tree produced by the `MatrixMulExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitMatrixMulExpression

          void exitMatrixMulExpression(DmlParser.MatrixMulExpressionContext ctx)

      Exit a parse tree produced by the `MatrixMulExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterMultiIdExpression

          void enterMultiIdExpression(DmlParser.MultiIdExpressionContext ctx)

      Enter a parse tree produced by the `MultiIdExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitMultiIdExpression

          void exitMultiIdExpression(DmlParser.MultiIdExpressionContext ctx)

      Exit a parse tree produced by the `MultiIdExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterBooleanAndExpression

          void enterBooleanAndExpression(DmlParser.BooleanAndExpressionContext ctx)

      Enter a parse tree produced by the `BooleanAndExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitBooleanAndExpression

          void exitBooleanAndExpression(DmlParser.BooleanAndExpressionContext ctx)

      Exit a parse tree produced by the `BooleanAndExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterBooleanOrExpression

          void enterBooleanOrExpression(DmlParser.BooleanOrExpressionContext ctx)

      Enter a parse tree produced by the `BooleanOrExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitBooleanOrExpression

          void exitBooleanOrExpression(DmlParser.BooleanOrExpressionContext ctx)

      Exit a parse tree produced by the `BooleanOrExpression` labeled alternative in `DmlParser.expression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterTypedArgNoAssign

          void enterTypedArgNoAssign(DmlParser.TypedArgNoAssignContext ctx)

      Enter a parse tree produced by `DmlParser.typedArgNoAssign()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitTypedArgNoAssign

          void exitTypedArgNoAssign(DmlParser.TypedArgNoAssignContext ctx)

      Exit a parse tree produced by `DmlParser.typedArgNoAssign()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterTypedArgAssign

          void enterTypedArgAssign(DmlParser.TypedArgAssignContext ctx)

      Enter a parse tree produced by `DmlParser.typedArgAssign()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitTypedArgAssign

          void exitTypedArgAssign(DmlParser.TypedArgAssignContext ctx)

      Exit a parse tree produced by `DmlParser.typedArgAssign()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterParameterizedExpression

          void enterParameterizedExpression(DmlParser.ParameterizedExpressionContext ctx)

      Enter a parse tree produced by `DmlParser.parameterizedExpression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitParameterizedExpression

          void exitParameterizedExpression(DmlParser.ParameterizedExpressionContext ctx)

      Exit a parse tree produced by `DmlParser.parameterizedExpression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterStrictParameterizedExpression

          void enterStrictParameterizedExpression(DmlParser.StrictParameterizedExpressionContext ctx)

      Enter a parse tree produced by `DmlParser.strictParameterizedExpression()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitStrictParameterizedExpression

          void exitStrictParameterizedExpression(DmlParser.StrictParameterizedExpressionContext ctx)

      Exit a parse tree produced by `DmlParser.strictParameterizedExpression()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterStrictParameterizedKeyValueString

          void enterStrictParameterizedKeyValueString(DmlParser.StrictParameterizedKeyValueStringContext ctx)

      Enter a parse tree produced by `DmlParser.strictParameterizedKeyValueString()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitStrictParameterizedKeyValueString

          void exitStrictParameterizedKeyValueString(DmlParser.StrictParameterizedKeyValueStringContext ctx)

      Exit a parse tree produced by `DmlParser.strictParameterizedKeyValueString()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterMl_type

          void enterMl_type(DmlParser.Ml_typeContext ctx)

      Enter a parse tree produced by `DmlParser.ml_type()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitMl_type

          void exitMl_type(DmlParser.Ml_typeContext ctx)

      Exit a parse tree produced by `DmlParser.ml_type()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterValueType

          void enterValueType(DmlParser.ValueTypeContext ctx)

      Enter a parse tree produced by `DmlParser.valueType()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitValueType

          void exitValueType(DmlParser.ValueTypeContext ctx)

      Exit a parse tree produced by `DmlParser.valueType()`.
      Parameters:
        `ctx` - the parse tree

    - #### enterMatrixDataTypeCheck

          void enterMatrixDataTypeCheck(DmlParser.MatrixDataTypeCheckContext ctx)

      Enter a parse tree produced by the `MatrixDataTypeCheck` labeled alternative in `DmlParser.dataType()`.
      Parameters:
        `ctx` - the parse tree

    - #### exitMatrixDataTypeCheck

          void exitMatrixDataTypeCheck(DmlParser.MatrixDataTypeCheckContext ctx)

      Exit a parse tree produced by the `MatrixDataTypeCheck` labeled alternative in `DmlParser.dataType()`.
      Parameters:
        `ctx` - the parse tree

Copyright © 2020 The Apache Software Foundation. All rights reserved.